# Circuit Playground Express fart and laugh box
# left arrow = fart : right arrow = laugh
# i am not proud of this ... - scruss - 2017-12
# !!! you need to install the  Adafruit CircuitPython IRRemote
#     library:
#     https://github.com/adafruit/Adafruit_CircuitPython_IRRemote/releases

# adafruit mini remote left and right keys, captured IR codes
lrkeys=[
    [9124, 4487, 628, 511, 626, 513, 629, 509, 623, 515, 622, 517, 619,
     519, 623, 515, 627, 511, 626, 1624, 619, 1635, 619, 1626, 628,
     1621, 626, 1624, 625, 1632, 612, 518, 619, 1631, 626, 512, 622,
     517, 620, 522, 615, 1630, 623, 515, 622, 516, 621, 517, 619, 520,
     628, 1621, 622, 1627, 626, 1624, 620, 518, 619, 1632, 622, 1627,
     626, 1624, 620, 1631, 622], # left
    [9119, 4486, 624, 514, 619, 519, 628, 510, 627, 511, 626, 515, 622,
     513, 624, 514, 622, 516, 621, 1628, 625, 1627, 617, 1629, 625,
     1625, 629, 1620, 622, 1627, 627, 512, 625, 1623, 621, 517, 629,
     1622, 622, 515, 622, 1627, 626, 511, 626, 512, 625, 519, 618, 514,
     623, 1627, 626, 511, 626, 1623, 620, 518, 619, 1630, 623, 1626,
     628, 1620, 623, 1626, 627] # right
    ]

# audio files are CC0 from http://freesound.org/, fiddled down to 16kHz
files=[
    "94989__doubledeanart__bad-chili-fart.wav",
    "243022__plasterbrain__shrieking-laughter.wav"
    ]

import pulseio
import board
import audioio
import digitalio

speaker_enable = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker_enable.switch_to_output(value=True)

import adafruit_irremote
pulsein = pulseio.PulseIn(board.REMOTEIN, maxlen=120, idle_state=True)
decoder = adafruit_irremote.GenericDecode()

# Fuzzy pulse comparison function:
# nicked from https://learn.adafruit.com/ir-sensor/circuitpython
def fuzzy_pulse_compare(pulse1, pulse2, fuzzyness=0.2):
    if len(pulse1) != len(pulse2):
        return False
    for i in range(len(pulse1)):
        threshold = int(pulse1[i] * fuzzyness)
        if abs(pulse1[i] - pulse2[i]) > threshold:
            return False
    return True

while True:
    pulses = decoder.read_pulses(pulsein)
    # print("Heard", len(pulses), "Pulses:", pulses)
    for i in range(len(lrkeys)):
        if fuzzy_pulse_compare(pulses, lrkeys[i]):
            # print("Code match:", i)
            f = open(files[i], "rb")
            a = audioio.AudioOut(board.A0, f)
            a.play()
    # print("----------------------------")
